"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionalAdapterMongoDB = void 0;
class TransactionalAdapterMongoDB {
    constructor(options) {
        /** cannot proxy an `undefined` value */
        this.supportsTransactionProxy = false;
        this.connectionToken = options.mongoClientToken;
        this.defaultTxOptions = options.defaultTxOptions;
    }
    optionsFactory(mongoClient) {
        return {
            wrapWithTransaction: async (options, fn, setTx) => {
                var _a;
                return mongoClient.withSession((_a = options.sessionOptions) !== null && _a !== void 0 ? _a : {}, async (session) => session.withTransaction(() => {
                    setTx(session);
                    return fn();
                }, options));
            },
            getFallbackInstance: () => undefined,
        };
    }
}
exports.TransactionalAdapterMongoDB = TransactionalAdapterMongoDB;
//# sourceMappingURL=transactional-adapter-mongodb.js.map